package quimufu.colourful_portals;

import net.fabricmc.api.ClientModInitializer;
import net.fabricmc.fabric.api.blockrenderlayer.v1.BlockRenderLayerMap;
import net.fabricmc.fabric.api.client.render.fluid.v1.FluidRenderHandlerRegistry;
import net.minecraft.client.render.RenderLayer;
import quimufu.colourful_portals.client.CommonPortalFluidRenderer;
import quimufu.colourful_portals.client.CommonPortalFluidRendererV1;
import quimufu.colourful_portals.client.CommonPortalFluidRendererV2;
import quimufu.colourful_portals.client.PortalFluidRenderHandler;
import quimufu.colourful_portals.config.ColourfulPortalConfig;

public class ColourfulPortalsModClient implements ClientModInitializer {
    public static ThreadLocal<CommonPortalFluidRenderer> FLUID_RENDERER = ThreadLocal.withInitial(CommonPortalFluidRendererV2::new);

    public void onInitializeClient() {
        BlockRenderLayerMap.INSTANCE.putBlock(ColourfulPortalsMod.PORTAL_BLOCK, RenderLayer.getTranslucent());
        BlockRenderLayerMap.INSTANCE.putFluid(ColourfulPortalsMod.PORTAL_FLUID, RenderLayer.getTranslucent());
        FluidRenderHandlerRegistry.INSTANCE.register(ColourfulPortalsMod.PORTAL_FLUID, new PortalFluidRenderHandler());
        ColourfulPortalConfig.registerListener(this::onConfigUpdate);
        onConfigUpdate();
    }

    private void onConfigUpdate() {
        if(ColourfulPortalConfig.blockyPortalFluid){
            FLUID_RENDERER = ThreadLocal.withInitial(CommonPortalFluidRendererV1::new);
        } else {
            FLUID_RENDERER = ThreadLocal.withInitial(CommonPortalFluidRendererV2::new);
        }

    }

}